package mezz.jei.common.input.handlers;

import mezz.jei.common.input.IInternalKeyMappings;
import mezz.jei.common.input.UserInput;
import net.minecraft.class_3675;
import net.minecraft.class_437;
import mezz.jei.common.input.IUserInputHandler;
import java.util.Optional;
import java.util.function.Supplier;

public class ProxyInputHandler implements IUserInputHandler {
	private final Supplier<IUserInputHandler> source;

	public ProxyInputHandler(Supplier<IUserInputHandler> source) {
		this.source = source;
	}

	@Override
	public Optional<IUserInputHandler> handleUserInput(class_437 screen, UserInput input, IInternalKeyMappings keyBindings) {
		return this.source.get().handleUserInput(screen, input, keyBindings);
	}

	@Override
	public void handleMouseClickedOut(class_3675.class_306 input) {
		this.source.get().handleMouseClickedOut(input);
	}

	@Override
	public boolean handleMouseScrolled(double mouseX, double mouseY, double scrollDelta) {
		return this.source.get().handleMouseScrolled(mouseX, mouseY, scrollDelta);
	}

	@Override
	public Optional<IUserInputHandler> handleDragStart(class_437 screen, UserInput input) {
		return this.source.get().handleDragStart(screen, input);
	}

	@Override
	public Optional<IUserInputHandler> handleDragComplete(class_437 screen, UserInput input) {
		return this.source.get().handleDragComplete(screen, input);
	}

	@Override
	public void handleDragCanceled() {
		this.source.get().handleDragCanceled();
	}
}
